/*
****************************************************************************

              Copyright 1991, by FUJITSU LIMITED
              Copyright 1991, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Auther: Riki	Kawaguchi       FUJITSU LIMITED
	A.	Yukisita        FUJITSU LIMITED
	Hideki  Hiura           (hhiura@Sun.COM) Sun Microsystems, Inc.

****************************************************************************
*/
#ifndef lint
#ident  "@(#)HttTextConv.c	1.13    93/02/12 SMI"
#endif

#include <stdlib.h>
#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#if XlibSpecificationRelease != 5
#include <X11/XlibR5.h>
#endif /* XlibSpecificationRelease */
#include "XSunExt.h"

#include <X11/Xutil.h>
#include <X11/Xresource.h>
#ifdef SVR4
#include "limits.h"
#endif
#include "Htt.h"
#include "XSunIMProt.h"
#include "HttXsfSun.h"

#ifndef MB_LEN_MAX
#define MB_LEN_MAX 4
#endif
#ifndef WCHAR_SIZE
#define WCHAR_SIZE 2
#endif
extern void
Xsf_XIMTextToCompound(ximtext, textarea, len)
    XIMText        *ximtext;
    char           *textarea;
    int            *len;	/* return */
{

    if (!ximtext) {
	*len = 0;
	return;
    }
    if ((!ximtext->length)
	|| (!ximtext->string.multi_byte)) {
	*len = 0;
	return;
    }
    if (ximtext->encoding_is_wchar) {
	/*
	 * The following function is named as EUC_TO.. but according to the
	 * source, this seems to mean EUC encoded wide char. UGAH!!
	 */
	*len = EUC_To_CompoundText(textarea,
				   ximtext->string.wide_char,
				   ximtext->length);
#ifdef DEBUG
	dbg_printf("textconv: input wchar text |%ws|\n",
					ximtext->string.wide_char);
	_iml_xdmem(ximtext->string.wide_char,
		   ximtext->length * sizeof(wchar_t));
	dbg_printf("textconv: out put CT\n");
	_iml_xdmem(textarea, len + 2);
#endif	/* DEBUG */
    } else {
	int             mbbl = (ximtext->length + 1) * MB_LEN_MAX;
	wchar_t        *wctext = (wchar_t *) calloc(sizeof(wchar_t), mbbl);

	mbstowcs(wctext, ximtext->string.multi_byte, mbbl);
	wctext[mbbl] = NULL;
	*len = wslen(wctext);
	/*
	 * The following function is named as EUC_TO.. but according to the
	 * source, this seems to mean EUC encoded wide char. UGAH!!
	 */
	*len = EUC_To_CompoundText(textarea, wctext, *len);
#ifdef DEBUG
	dbg_printf("textconv: input MB text |%s|\n",
				ximtext->string.multi_byte);
	_iml_xdmem(ximtext->string.multi_byte,
		   ximtext->length * MB_LEN_MAX);
	dbg_printf("textconv: converted WC text |%ws|\n", wctext);
	_iml_xdmem(wctext, strlen(wctext));
	dbg_printf("textconv: out put CT\n");
	_iml_xdmem(textarea, len + 2);
#endif	/* DEBUG */
	free(wctext);
    }
    return ;
}

/*
 * Convert mbs to wcs when XIMText is mbs.
 */
extern int
Xsf_XIMTextToWcs( ximtext, textarea )
    XIMText        *ximtext;
    wchar_t        **textarea;
{
    *textarea = NULL ;

    if (!ximtext)
	return ( 0 ) ;

    if ((!ximtext->length)
	|| (!ximtext->string.multi_byte))
	return ( 0 ) ;

	if (ximtext->encoding_is_wchar) {
		int	wcbl = ( ximtext->length + 1 ) * sizeof(wchar_t) ;
		*textarea = (wchar_t *)malloc( wcbl ) ;
		(void)bzero( *textarea, wcbl ) ;
		(void)bcopy( (char *)ximtext->string.wide_char,
		(char *)*textarea, ximtext->length * sizeof(wchar_t) ) ;
		return ( ximtext->length ) ;
	} else {
		int             mbbl = (ximtext->length + 1) * MB_LEN_MAX;
		*textarea = (wchar_t *) calloc(sizeof(wchar_t), mbbl);
		mbstowcs(*textarea, ximtext->string.multi_byte, mbbl);
		textarea[mbbl] = NULL;
		return ( wslen( *textarea ) ) ;
	}
}
